package Status;

use strict;

use vars qw($ENABLED $STATUS $WITH_PARENT $ADMIN $CLIENT $EXPIRED);

$ENABLED = 0;
$STATUS = 1;
$WITH_PARENT = 2;
$ADMIN = 16;
$CLIENT = 64;
$EXPIRED = 256;

my $MASK = $STATUS | $WITH_PARENT | $ADMIN | $CLIENT | $EXPIRED;

sub makeDisabledBy {
  return ::XmlNode('disabled-by', 'attributes' => {'name', $_[0] });
}

sub make {
	my ($status) = @_;

    my $node = ::XmlNode('status');

    $node->{'ADDCHILD'}->(::XmlNode('enabled')) unless $status & $MASK;

    my $statuses = { $STATUS => 'domadm', $WITH_PARENT => 'parent',
                     $ADMIN => 'admin', $CLIENT => 'client',
                     $EXPIRED => 'expired' };
    foreach my $s (keys(%{$statuses})) {
      $node->{'ADDCHILD'}->(makeDisabledBy($statuses->{$s})) if ($status & $s);
    }
	return $node;
}

1;
